package cnpc;

import java.awt.*;
import javax.swing.*;

public class CNPC_ProgressFrame extends JFrame
{
	private static CNPC_ProgressFrame me = null;
	public static CNPC_ProgressFrame instance()
	{
		if(me == null)
			me = new CNPC_ProgressFrame();
		return me;
	}


	private static final int TITLE_BAR_HEIGHT = 27;
	private static final int WEST_BUFFER = 20;
	private static final int NORTH_BUFFER = 20;
	private static final int EAST_BUFFER = 20;
	private static final int SOUTH_BUFFER = 30;
	private static final int SEPARATION = 10;

	private final SpringLayout layout = new SpringLayout();
	private final Container content;

	private final JLabel processLabel = new JLabel("Test");
	private final JProgressBar progressBar = new JProgressBar(0, 100);

	private CNPC_ProgressFrame()
	{
		content = getContentPane();
		content.setLayout(layout);

		setTitle("Chrononauts PC");
		setLocation(200, 200);
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		initProgressBar();
		layoutFrame();

		setVisible(false);
	}

	private void initProgressBar()
	{
		progressBar.setStringPainted(true);
		progressBar.setValue(0);
		progressBar.setString("");
	}

	private void layoutFrame()
	{
		progressBar.setPreferredSize(new Dimension(350, 30));

		layout.putConstraint(SpringLayout.NORTH, processLabel, NORTH_BUFFER, SpringLayout.NORTH, content);
		layout.putConstraint(SpringLayout.WEST, processLabel, WEST_BUFFER, SpringLayout.WEST, content);
		layout.putConstraint(SpringLayout.NORTH, progressBar, SEPARATION, SpringLayout.SOUTH, processLabel);
		layout.putConstraint(SpringLayout.WEST, progressBar, WEST_BUFFER, SpringLayout.WEST, content);
		content.add(processLabel);
		content.add(progressBar);

		int width = WEST_BUFFER + progressBar.getPreferredSize().width + EAST_BUFFER;
		int height = TITLE_BAR_HEIGHT + NORTH_BUFFER + processLabel.getPreferredSize().height + SEPARATION + progressBar.getPreferredSize().height + SOUTH_BUFFER;
		setSize(width, height);

		processLabel.setText("");
	}

	public void finish()
	{
		me = null;
		dispose();
	}


	public void resetProgress()
	{
		setProgress(0, "");
	}

	public void setProcessLabel(String label)
	{
		processLabel.setText(label);
	}

	public void setProgress(int percentage, String text)
	{
		progressBar.setValue(percentage % 101);
		progressBar.setString(text);
	}
}
