package cnpc.ai;

import cnpc.engine.*;

import java.util.*;

class AI_Constants
{
	public static final Hashtable<Integer, AI_PlayCard> playCardDirectory = new Hashtable<Integer, AI_PlayCard>();
	public static final Hashtable<Integer, AI_TimelineCard> timelineCardDirectory = new Hashtable<Integer, AI_TimelineCard>();
	public static final Hashtable<Integer, AI_IdCard> idCardDirectory = new Hashtable<Integer, AI_IdCard>();
	public static final Hashtable<Integer, AI_MissionCard> missionCardDirectory = new Hashtable<Integer, AI_MissionCard>();



	public static final String PATH_TO_DATA = "../data/";
	public static final String PATH_TO_ENGINE_DATA = "/enginedata/";
	public static final String PATH_TO_AI_DATA = "/aidata/";
	public static final String ENGINE_PLAY_CARDS_PATH = "playcarddata.c2b9";
	public static final String ENGINE_ID_CARDS_PATH = "idcarddata.c2b9";
	public static final String ENGINE_MISSION_CARDS_PATH = "missioncarddata.c2b9";
	public static final String ENGINE_TIMELINE_CARDS_PATH = "timelinedata.c2b9";


	public static final String XML_FILE_EXTENSION = ".c2b9";

	public static final int NULL_PATCH = CN_Constants.NULL_PATCH;

	public static final String DEFAULT_STRING = "__default";
	public static final String NULL_STRING = "___NULL___";


	//XML attribute names
	public static final String TYPE_ATTRIBUTE_STRING = "type";
	public static final String STATE_ATTRIBUTE_STRING = "state";
	public static final String CARD_ATTRIBUTE_STRING = "card";
	public static final String NAME_ATTRIBUTE_STRING = "name";
	public static final String WEIGHT_ATTRIBUTE_STRING = "weight";


	public static final String TIMELINE_CARD_TYPE_LINCHPIN = "Linchpin";
	public static final String TIMELINE_CARD_TYPE_RIPPLEPOINT = "Ripplepoint";

	//constants for AI_CardScenarioGroup
	public static final int MAX_TRIES = 5;
	public static final String INPUT_STATE_SCENARIOS_STATE_MAIN = "Main";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_CARD_PLAY = "GetCardPlay";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_DECK_SELECTION = "GetDeckSelection";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_DISCARDS_SELECTION = "GetDiscardsSelection";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_ARTIFACT_SELECTION = "GetArtifactSelection";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_HAND_SELECTION = "GetHandSelection";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_LINCHPIN_SELECTION = "GetLinchpinSelection";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_RIPPLEPOINT_SELECTION = "GetRipplepointSelection";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_ID_SELECTION = "GetIdSelection";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_MISSION_SELECTION = "GetMissionSelection";
	public static final String INPUT_STATE_SCENARIOS_STATE_GET_DIRECTION_SELECTION = "GetDirectionSelection";

	//constants for AI_Comparison
	public static final String ARTIFACT_COMPARISON_STRING = "ArtifactComparison";
	public static final String DECK_COMPARISON_STRING = "DeckComparison";
	public static final String DISCARDS_COMPARISON_STRING = "DiscardsComparison";
	public static final String HAND_CARD_COMPARISON_STRING = "HandCardComparison";
	public static final String HAND_SIZE_COMPARISON_STRING = "HandSizeComparison";
	public static final String LINCHPIN_COMPARISON_STRING = "LinchpinComparison";
	public static final String RIPPLEPOINT_COMPARISON_STRING = "RipplepointComparison";

	//constants for AI_ActionSpecifier
	public static final String ARTIFACT_SELECTION_SPECIFIER_STRING = "ArtifactSelection";
	public static final String CARD_PLAY_SPECIFIER_STRING = "CardPlay";
	public static final String DECK_SELECTION_SPECIFIER_STRING = "DeckSelection";
	public static final String DIRECTION_SELECTION_SPECIFIER_STRING = "DirectionSelection";
	public static final String DISCARDS_SELECTION_SPECIFIER_STRING = "DiscardsSelection";
	public static final String HAND_SELECTION_SPECIFIER_STRING = "HandSelection";
	public static final String ID_SELECTION_SPECIFIER_STRING = "IdSelection";
	public static final String LINCHPIN_SELECTION_SPECIFIER_STRING = "LinchpinSelection";
	public static final String MAIN_SPECIFIER_STRING = "Main";
	public static final String MISSION_SELECTION_SPECIFIER_STRING = "MissionSelection";
	public static final String RIPPLEPOINT_SELECTION_SPECIFIER_STRING = "RipplepointSelection";

	//Constants for AI_MissionCard
	public static final String EXACT_TARGET_TYPE = "Exact";
	public static final String MOST_AUTHENTIC_TARGET_TYPE = "MostAuthentic";
	public static final String NOT_MOST_AUTHENTIC_TARGET_TYPE = "NotMostAuthentic";
	public static final int NONEXISTENT_AUTHENTICITY = CN_Constants.NONEXISTENT_AUTHENTICITY;



}
