package cnpc.ai;

import java.util.*;
import org.w3c.dom.*;

class AI_Linchpin extends AI_TimelineCard
{
	private AI_Ripplepoint[] ripples;

	private boolean locked = false;

	public AI_Linchpin(String identity_in, String cardName_in)
	{
		super(identity_in, cardName_in);
	}


	public void setRipples(AI_Ripplepoint[] allRipplepoints) throws AI_FatalException
	{
		if(locked)
			throw new AI_FatalException("AI_Linchpin.setRipples: Already locked!");

		ArrayList<AI_Ripplepoint> currentRipplepoints = new ArrayList<AI_Ripplepoint>();

		for(AI_Ripplepoint ripplepoint : allRipplepoints)
		{
			AI_Linchpin[] rippledBy = ripplepoint.getRippledBy();
			for(AI_Linchpin linchpin : rippledBy)
			{
				if(linchpin.identity.equals(identity))
				{
					currentRipplepoints.add(ripplepoint);
					break;
				}
			}
		}

		ripples = new AI_Ripplepoint[currentRipplepoints.size()];
		for(int i = 0; i < currentRipplepoints.size(); i++)
		{
			ripples[i] = currentRipplepoints.get(i);
		}

		lock();
	}

	public void lock() throws AI_FatalException
	{
		if(locked)
			throw new AI_FatalException("AI_Linchpin.lock: Already locked!");

		locked = true;
	}



	public AI_Ripplepoint[] getRipples() throws AI_FatalException
	{
		if(!locked)
			throw new AI_FatalException("AI_Linchpin.getRipples: Must be locked!");

		AI_Ripplepoint[] returnValue = new AI_Ripplepoint[ripples.length];
		for(int i = 0; i < ripples.length; i++)
		{
			returnValue[i] = ripples[i];
		}
		return returnValue;
	}
}
