package cnpc.engine;

import java.util.*;

class CN_CardStack<E extends CN_GameCard> extends Stack<E>
{
	public void shuffle()
	{
		ArrayList<E> listToShuffle = new ArrayList<E>();

		while(!empty())
		{
			listToShuffle.add(pop());
		}

		Collections.shuffle(listToShuffle);

		while(!listToShuffle.isEmpty())
		{
			push(listToShuffle.remove(0));
		}
	}

	public Stack<Integer> toGameStateStack()
	{
		Stack<Integer> returnValue = new Stack<Integer>();
		Stack<E> intermStack = getInvertedStack();

		while(!intermStack.empty())
		{
			returnValue.push(intermStack.pop().cardNumber);
		}

		return returnValue;
	}


	public void addFromStack(Stack<E> sourceStack)
	{
		Stack<E> intermediateStack = new Stack<E>();

		while(!sourceStack.empty())
		{
			intermediateStack.push(sourceStack.pop());
		}

		E currentE;
		while(!intermediateStack.empty())
		{
			currentE = intermediateStack.pop();
			sourceStack.push(currentE);
			push(currentE);
		}
	}


	private Stack<E> getInvertedStack()
	{
		Stack<E> returnValue = new Stack<E>();
		for(int i = size() - 1; i >= 0; i--)
		{
			returnValue.push(get(i));
		}
		return returnValue;
	}


	public boolean contains(E elem)
	{
		for(E card : this)
		{
			if(card.cardNumber == elem.cardNumber)
			{
				return true;
			}
		}
		return false;
	}


}


