package cnpc.engine;

public final class CN_Constants
{
	public static final CN_CardDirectory<CN_PlayCard> playCardDirectory = new CN_CardDirectory<CN_PlayCard>();
	public static final CN_CardDirectory<CN_TimelineCard> timelineCardDirectory = new CN_CardDirectory<CN_TimelineCard>();
	public static final CN_CardDirectory<CN_IdCard> idCardDirectory = new CN_CardDirectory<CN_IdCard>();
	public static final CN_CardDirectory<CN_MissionCard> missionCardDirectory = new CN_CardDirectory<CN_MissionCard>();

	public static enum InputState {MAIN, GET_ARTIFACT_SELECTION, GET_HAND_SELECTION, GET_LINCHPIN_SELECTION, GET_RIPPLEPOINT_SELECTION, GET_ID_SELECTION, GET_MISSION_SELECTION, GET_CARD_PLAY, GET_DIRECTION_SELECTION, GET_DECK_SELECTION, GET_DISCARDS_SELECTION, END_TURN, BETWEEN_TURNS, PROCESSING};
	public static enum InputConstraint{NONE, CURRENT_PLAYER, NOT_CURRENT_PLAYER, PLAYABLE, NOT_A_TIMEWARP};


	//Bascom constants
	public static final int BASCOM_IDENT_CONDITIONAL = 1001;
	public static final int BASCOM_ELSE = 1002;
	public static final int BASCOM_END_IF = 1003;
	public static final int BASCOM_TRANSFER_ARTIFACT = 1004;
	public static final int BASCOM_PLAY_ARTIFACT = 1005;
	public static final int BASCOM_DISCARD_ARTIFACT = 1006;
	public static final int BASCOM_DISCARD_CARD = 1007;
	public static final int BASCOM_DRAW = 1008;
	public static final int BASCOM_TRANSFER_DECK_TO_DISCARDS = 1009;
	public static final int BASCOM_TRANSFER_DECK_TO_ARTIFACTS = 1010;
	public static final int BASCOM_TRANSFER_DECK_TO_HAND = 1011;
	public static final int BASCOM_MOVE_DISCARD_TO_TOP = 1012;
	public static final int BASCOM_TRANSFER_DISCARDS_TO_ARTIFACTS = 1013;
	public static final int BASCOM_TRANSFER_DISCARDS_TO_HAND = 1014;
	public static final int BASCOM_EXECUTE_CARD = 1015;
	public static final int BASCOM_BACK_UP_HAND = 1016;
	public static final int BASCOM_RESTORE_BACKED_UP_HAND = 1017;
	public static final int BASCOM_FLIP_LINCHPIN = 1018;
	public static final int BASCOM_TRANSFER_HAND_TO_RIPPLEPOINT = 1019;
	public static final int BASCOM_DO_VORTEX = 1020;
	public static final int BASCOM_PASS_HANDS = 1021;
	public static final int BASCOM_NEW_ID = 1022;
	public static final int BASCOM_SWITCH_IDS = 1023;
	public static final int BASCOM_NEW_MISSION = 1024;
	public static final int BASCOM_SWITCH_MISSIONS = 1025;
	public static final int BASCOM_SAVE_GAME_STATE = 1026;
	public static final int BASCOM_LOAD_GAME_STATE = 1027;
	public static final int BASCOM_CLEAR_GAME_STATE = 1028;
	public static final int BASCOM_RESHUFFLE_DECK = 1029;
	public static final int BASCOM_RESHUFFLE_IDS = 1030;
	public static final int BASCOM_RESHUFFLE_MISSIONS = 1031;
	public static final int BASCOM_GET_ARTIFACT_SELECTION = 1032;
	public static final int BASCOM_GET_HAND_SELECTION = 1033;
	public static final int BASCOM_GET_LINCHPIN_SELECTION = 1034;
	public static final int BASCOM_GET_RIPPLEPOINT_SELECTION = 1035;
	public static final int BASCOM_GET_ID_SELECTION = 1036;
	public static final int BASCOM_GET_MISSION_SELECTION = 1037;
	public static final int BASCOM_GET_CARD_PLAY = 1038;
	public static final int BASCOM_GET_DIRECTION_SELECTION = 1039;
	public static final int BASCOM_GET_DECK_SELECTION = 1040;
	public static final int BASCOM_GET_DISCARDS_SELECTION = 1041;
	public static final int BASCOM_END_TURN = 1042;
	public static final int BASCOM_SKIP_QUEUE_ITEMS = 1043;
	public static final int BASCOM_DRAW_REAL = 1044;
	public static final int BASCOM_SPECIAL_LOAD_PARAMETER_LITERAL = 2001;
	public static final int BASCOM_SPECIAL_LOAD_PARAMETER_HASH = 2002;
	public static final int BASCOM_SPECIAL_REMOVE_PARAMETER = 2003;

	//Constants for CN_Engine
	public static final int MAXPLAYERS = 6;
	public static final String DISCARDONEHASH = "__discardOne";
	public static final String DISCARDTWOHASH = "__discardTwo";
	public static final String SECONDDISCARDHASH = "__secondDiscard";

	public static final String CONSTRAINT_NONE = "none";
	public static final String CONSTRAINT_CURRENTPLAYER = "currentplayer";
	public static final String CONSTRAINT_NOTCURRENTPLAYER = "notcurrentplayer";
	public static final String CONSTRAINT_PLAYABLE = "playable";
	public static final String CONSTRAINT_NOT_A_TIMEWARP = "notatimewarp";

	public static final String SPECIALPARAM_CURRENTPLAYERHASH = "__currentPlayer";
	public static final String SPECIALPARAM_PLAYEDCARDHASH = "__playedCard";

	public static final int STARTING_NUMBER_OF_CARDS = 3;

	public static final String LEFT_STRING = "left";
	public static final String RIGHT_STRING = "right";

	public static final String UNPLAYABLE_ALL_LINCHPINS = "__ALL";

	public static final int END_OF_UNIVERSE_PARADOX_COUNT = 13;

	public static final String CANCELABLE_STRING = "cancelable";
	public static final String NOT_CANCELABLE_STRING = "not_cancelable";



	//Constants for CN_Initializer
	public static final String PATH_TO_DATA = "../data/";
	public static final String PATH_TO_ENGINE_DATA = "/enginedata/";
	public static final String PLAY_CARDS_PATH = "playcarddata.c2b9";
	public static final String ID_CARDS_PATH = "idcarddata.c2b9";
	public static final String MISSION_CARDS_PATH = "missioncarddata.c2b9";
	public static final String TIMELINE_CARDS_PATH = "timelinedata.c2b9";
	public static final int MAXAMOUNTINDECK = 20;

	public static final String INIT_IDENT_CONDITIONAL = "IdentConditional";
	public static final String INIT_ELSE = "Else";
	public static final String INIT_END_IF = "EndIf";
	public static final String INIT_TRANSFER_ARTIFACT = "TransferArtifact";
	public static final String INIT_PLAY_ARTIFACT = "PlayArtifact";
	public static final String INIT_DISCARD_ARTIFACT = "DiscardArtifact";
	public static final String INIT_DISCARD_CARD = "DiscardCard";
	public static final String INIT_DRAW = "Draw";
	public static final String INIT_TRANSFER_DECK_TO_DISCARDS = "TransferDeckToDiscards";
	public static final String INIT_TRANSFER_DECK_TO_ARTIFACTS = "TransferDeckToArtifacts";
	public static final String INIT_TRANSFER_DECK_TO_HAND = "TransferDeckToHand";
	public static final String INIT_MOVE_DISCARD_TO_TOP = "MoveDiscardsToTop";
	public static final String INIT_TRANSFER_DISCARDS_TO_ARTIFACTS = "TransferDiscardsToArtifacts";
	public static final String INIT_TRANSFER_DISCARDS_TO_HAND = "TransferDiscardsToHand";
	public static final String INIT_EXECUTE_CARD = "ExecuteCard";
	public static final String INIT_BACK_UP_HAND = "BackUpHand";
	public static final String INIT_RESTORE_BACKED_UP_HAND = "RestoreBackedUpHand";
	public static final String INIT_FLIP_LINCHPIN = "FlipLinchpin";
	public static final String INIT_TRANSFER_HAND_TO_RIPPLEPOINT = "TransferHandToRipplepoint";
	public static final String INIT_DO_VORTEX = "DoVortex";
	public static final String INIT_PASS_HANDS = "PassHands";
	public static final String INIT_NEW_ID = "NewId";
	public static final String INIT_SWITCH_IDS = "SwitchIds";
	public static final String INIT_NEW_MISSION = "NewMission";
	public static final String INIT_SWITCH_MISSIONS = "SwitchMissions";
	public static final String INIT_SAVE_GAME_STATE = "SaveGameState";
	public static final String INIT_LOAD_GAME_STATE = "LoadGameState";
	public static final String INIT_CLEAR_GAME_STATE = "ClearGameState";
	public static final String INIT_RESHUFFLE_DECK = "ReshuffleDeck";
	public static final String INIT_RESHUFFLE_IDS = "ReshuffleIds";
	public static final String INIT_RESHUFFLE_MISSIONS = "ReshuffleMissions";
	public static final String INIT_GET_ARTIFACT_SELECTION = "GetArtifactSelection";
	public static final String INIT_GET_HAND_SELECTION = "GetHandSelection";
	public static final String INIT_GET_LINCHPIN_SELECTION = "GetLinchpinSelection";
	public static final String INIT_GET_RIPPLEPOINT_SELECTION = "GetRipplepointSelection";
	public static final String INIT_GET_ID_SELECTION = "GetIdSelection";
	public static final String INIT_GET_MISSION_SELECTION = "GetMissionSelection";
	public static final String INIT_GET_CARD_PLAY = "GetCardPlay";
	public static final String INIT_GET_DIRECTION_SELECTION = "GetDirectionSelection";
	public static final String INIT_GET_DECK_SELECTION = "GetDeckSelection";
	public static final String INIT_GET_DISCARDS_SELECTION = "GetDiscardsSelection";
	public static final String INIT_END_TURN = "EndTurn";
	public static final String INIT_SKIP_QUEUE_ITEMS = "SkipQueueItems";
	public static final String INIT_DRAW_REAL = "DrawReal";
	public static final String INIT_SPECIAL_LOAD_PARAMETER_LITERAL = "LoadParameterLiteral";
	public static final String INIT_SPECIAL_LOAD_PARAMETER_HASH = "LoadParameterHash";
	public static final String INIT_SPECIAL_REMOVE_PARAMETER = "RemoveParameter";

	public static final String UNPLAYABLE_INIT_PATCH_STANDARD = "PatchStandard";
	public static final String UNPLAYABLE_INIT_INVERTER = "Inverter";
	public static final String UNPLAYABLE_INIT_DISCARDS_EMPTY = "DiscardsEmpty";
	public static final String UNPLAYABLE_INIT_NO_NON_TIMEWARP_DISCARDS_PLAYABLE = "NoNonTimewarpDiscardsPlayable";
	public static final String UNPLAYABLE_INIT_ARTIFACTS_NONE = "ArtifactsNone";
	public static final String UNPLAYABLE_INIT_ARTIFACTS_NOT_CURRENT_PLAYER = "ArtifactsNotCurrentPlayer";
	public static final String UNPLAYABLE_INIT_ARTIFACTS_NOT_OPPONENT = "ArtifactsNotOpponent";



	//Constants for CN_Ripplepoint
	public static final int NULL_PATCH = -1;

	//Constants for CN_Timeline
	public static final String TIMELINEFLIP = "__flip";
	public static final String TIMELINEUNFLIP = "__unflip";
	public static final String TIMELINEBOTH = "__both";

	public static final int NON_TERMINAL_YEAR = 2000000000;
	public static final int EARLY_YEAR = -2000000000;
	public static final String NON_TERMINAL_YEAR_STRING = "FarFuture";
	public static final String EARLY_YEAR_STRING = "NA";


	//Constants for CN_PlayCard
	public static final int NONEXISTENT_AUTHENTICITY = -1;


	//Constants for CN_MissionCard
	public static final String EXACT_TARGET_TYPE = "Exact";
	public static final String MOST_AUTHENTIC_TARGET_TYPE = "MostAuthentic";
	public static final String NOT_MOST_AUTHENTIC_TARGET_TYPE = "NotMostAuthentic";


	//Constants for CN_Player
	public static final int WINNING_HAND_SIZE = 10;


	//Constants for CN_GameState
	public static final int NO_VICTORIOUS_PLAYER = -1;
	public static final int END_OF_UNIVERSE = -13;
	public static final int NULL_BASCOM_SOURCE = -1;

	public static final int VICTORY_TYPE_ID = 1;
	public static final int VICTORY_TYPE_MISSION = 2;
	public static final int VICTORY_TYPE_CARDS = 3;
	public static final int VICTORY_TYPE_NULL = 0;

}
