package cnpc.engine;

/*

//TODO: make sure identity's are all unique

import javax.xml.xpath.*;
import org.xml.sax.*;
import java.io.*;

import java.util.*;


public class CN_Initializer
{
	XPathFactory factory;
	XPath xpath;

	CN_CardStack<CN_PlayCard> theDeck;
	CN_CardStack<CN_PlayCard> discardPile;
	CN_CardStack<CN_IdCard> idStack;
	CN_CardStack<CN_MissionCard> missionStack;

	enum CardType {PLAYCARD, IDCARD, MISSIONCARD, TIMELINECARD};

	public CN_Initializer()
	{
		factory = XPathFactory.newInstance();
		xpath = factory.newXPath();

		theDeck = new CN_CardStack<CN_PlayCard>();
		discardPile = new CN_CardStack<CN_PlayCard>();
		idStack = new CN_CardStack<CN_IdCard>();
		missionStack = new CN_CardStack<CN_MissionCard>();

		doInitialize();


	}




	private void loadTimeline()
	{
	}






















	protected void processXmlFiles(File dir, CardType cardType)
	{
		if(dir.isDirectory())
		{
			String[] children = dir.list();
			for(int i = 0; i < children.length; i++)
			{
				File child = new File(children[i]);
				if(!child.isDirectory())
				{
					processXmlFile(child, cardType);
				}
			}
		}
		else
		{
			System.out.println("Error in CN_Initializer/processXmlFiles():");
			System.out.println("File specified must be a directory.");
		}
	}


	protected void processXmlFile(File xmlFile, CardType cardType)
	{
		if(!isXml(xmlFile))
			return;

		String path;

		switch(cardType)
		{
			case PLAYCARD:
			{
				path = CN_Constants.PLAYCARDSPATH;
				break;
			}
			case IDCARD:
			{
				path = CN_Constants.IDCARDSPATH;
				break;
			}
			case MISSIONCARD:
			{
				path = CN_Constants.MISSIONCARDSPATH;
				break;
			}
			default:
			{
				return;
			}
		}

		InputSource source = new InputSource(path + xmlFile.getPath());

		if(cardType == CardType.PLAYCARD)
		{
			createPlayCard(source);
		}
		else if(cardType == CardType.IDCARD)
		{
			createIdCard(source);
		}
		else if(cardType == CardType.MISSIONCARD)
		{
			createMissionCard(source);
		}
		else
		{
			return;
		}
	}


	protected void createPlayCard(InputSource source)
	{
		String identity;
		String cardName;
		String frontImagePath;
		String backImagePath;
		String frontImagePath_large;
		String backImagePath_large;
		String amountInDeck;

		try
		{
			identity = xpath.evaluate("/CN_PlayCard/identity", source)	;
			cardName = xpath.evaluate("/CN_PlayCard/cardName", source);
			frontImagePath = xpath.evaluate("/CN_PlayCard/frontImagePath", source);
			backImagePath = xpath.evaluate("/CN_PlayCard/backImagePath", source);
			frontImagePath_large = xpath.evaluate("/CN_PlayCard/frontImagePath_large", source);
			backImagePath_large = xpath.evaluate("/CN_PlayCard/backImagePath_large", source);

			amountInDeck = xpath.evaluate("/CN_PlayCard/amountInDeck", source);
			int amount = 1;
			amount = decodeString(amountInDeck);
			if((amount < 0)||(amount > CN_Constants.MAXAMOUNTINDECK))
			{
				System.out.println("Error in CN_Initializer/createPlayCard()!  Details:");
				System.out.println("Amount in deck must be between 0 and " + CN_Constants.MAXAMOUNTINDECK);
				System.exit(1);
			}
			for(int i = 0; i < amount; i++)
			{
//temporarily commented out b/c of constructor issues
//				theDeck.push(new CN_PlayCard(identity, cardName, frontImagePath, backImagePath, frontImagePath_large, backImagePath_large));
			}

			System.out.println(identity + " loaded successfully (" + amount + " in deck).");
		}
		catch(XPathExpressionException e)
		{
			System.out.println("XPathExpressionException in CN_Initializer/createPlayCard()!  Details:");
			System.out.println(e.getMessage());
			System.exit(1);
		}
	}


	protected void createIdCard(InputSource source)
	{
		String identity;
		String cardName;
		String frontImagePath;
		String backImagePath;
		String frontImagePath_large;
		String backImagePath_large;
		String amountInDeck;

		try
		{
			identity = xpath.evaluate("/CN_IdCard/identity", source)	;
			cardName = xpath.evaluate("/CN_IdCard/cardName", source);
			frontImagePath = xpath.evaluate("/CN_IdCard/frontImagePath", source);
			backImagePath = xpath.evaluate("/CN_IdCard/backImagePath", source);
			frontImagePath_large = xpath.evaluate("/CN_IdCard/frontImagePath_large", source);
			backImagePath_large = xpath.evaluate("/CN_IdCard/backImagePath_large", source);

			amountInDeck = xpath.evaluate("/CN_IdCard/amountInDeck", source);
			int amount = 1;
			amount = decodeString(amountInDeck);
			if((amount < 0)||(amount > CN_Constants.MAXAMOUNTINDECK))
			{
				System.out.println("Error in CN_Initializer/createIdCard()!  Details:");
				System.out.println("Amount in deck must be between 0 and " + CN_Constants.MAXAMOUNTINDECK);
				System.exit(1);
			}
			for(int i = 0; i < amount; i++)
			{
//temporarily commented out b/c of constructor issues
//				idStack.push(new CN_IdCard(identity, cardName, frontImagePath, backImagePath, frontImagePath_large, backImagePath_large));
			}

			System.out.println(identity + " loaded successfully (" + amount + " in deck).");
		}
		catch(XPathExpressionException e)
		{
			System.out.println("XPathExpressionException in CN_Initializer/createIdCard()!  Details:");
			System.out.println(e.getMessage());
			System.exit(1);
		}
	}

	protected void createMissionCard(InputSource source)
	{
		String identity;
		String cardName;
		String frontImagePath;
		String backImagePath;
		String frontImagePath_large;
		String backImagePath_large;
		String amountInDeck;

		try
		{
			identity = xpath.evaluate("/CN_MissionCard/identity", source)	;
			cardName = xpath.evaluate("/CN_MissionCard/cardName", source);
			frontImagePath = xpath.evaluate("/CN_MissionCard/frontImagePath", source);
			backImagePath = xpath.evaluate("/CN_MissionCard/backImagePath", source);
			frontImagePath_large = xpath.evaluate("/CN_MissionCard/frontImagePath_large", source);
			backImagePath_large = xpath.evaluate("/CN_MissionCard/backImagePath_large", source);

			amountInDeck = xpath.evaluate("/CN_MissionCard/amountInDeck", source);
			int amount = 1;
			amount = decodeString(amountInDeck);
			if((amount < 0)||(amount > CN_Constants.MAXAMOUNTINDECK))
			{
				System.out.println("Error in CN_Initializer/createMissionCard()!  Details:");
				System.out.println("Amount in deck must be between 0 and " + CN_Constants.MAXAMOUNTINDECK);
				System.exit(1);
			}
			for(int i = 0; i < amount; i++)
			{
//temporarily commented out b/c of constructor issues
//				missionStack.push(new CN_MissionCard(identity, cardName, frontImagePath, backImagePath, frontImagePath_large, backImagePath_large));
			}

			System.out.println(identity + " loaded successfully (" + amount + " in deck).");
		}
		catch(XPathExpressionException e)
		{
			System.out.println("XPathExpressionException in CN_Initializer/createMissionCard()!  Details:");
			System.out.println(e.getMessage());
			System.exit(1);
		}
	}




	protected int decodeString(String string)
	{
		int returnValue = -9999;

		try
		{
			returnValue = Integer.decode(string);
		}
		catch(NumberFormatException e)
		{
			System.out.println("NumberFormatException in CN_Initializer/decodeString()!  Details:");
			System.out.println(e.getMessage());
			System.out.println("Note to user: Amount in deck must be a valid number");
			System.exit(1);
		}

		return returnValue;
	}



	protected boolean isXml(File file)
	{
		String path = file.getPath();
		String[] substrings = path.split("\\.");

		String fileExtension = substrings[substrings.length - 1];

		if(fileExtension.equalsIgnoreCase("xml"))
			return true;
		else
			return false;
	}


	protected void doInitialize()
	{
		System.out.println("\nLoading deck and playcards...");
		processXmlFiles(new File(CN_Constants.PLAYCARDSPATH), CardType.PLAYCARD);
		theDeck.shuffle();
		System.out.println("Deck loaded with " + theDeck.size() + " cards.");

		System.out.println("\nLoading id stack and idcards...");
		processXmlFiles(new File(CN_Constants.IDCARDSPATH), CardType.IDCARD);
		idStack.shuffle();
		System.out.println("ID Stack loaded with " + idStack.size() + " cards.");

		System.out.println("\nLoading mission stack and missioncards...");
		processXmlFiles(new File(CN_Constants.MISSIONCARDSPATH), CardType.MISSIONCARD);
		missionStack.shuffle();
		System.out.println("Mission Stack loaded with " + missionStack.size() + " cards.");
	}




}

*/
