package cnpc.engine;

import java.util.*;

class CN_Linchpin extends CN_TimelineCard
{
	private ArrayList<CN_Ripplepoint> linkups;
	public boolean flipLegal; //determines if it is currently legal, based on the last input to the bascom statechanger that changed the state to get linchpin selection, to flip this linchpin
	public boolean unflipLegal; //determines if it is currently legal, based on the last input to the bascom statechanger that changed the state to get linchpin selection, to unflip this linchpin

	private boolean isLocked;



	public CN_Linchpin(int cardNumber_in, String identity_in, String cardName_in, int year_in)
	{
		super(cardNumber_in, identity_in, cardName_in, year_in);
		linkups = new ArrayList<CN_Ripplepoint>();
		isLocked = false;
	}



	public void lockLinkups()
	{
		isLocked = true;
	}

	public void addLinkup(CN_Ripplepoint linkup) throws CN_FatalException
	{
		if(!isLocked)
		{
			if(!linkups.contains(linkup))
				linkups.add(linkup);
		}
		else
		{
			throw new CN_FatalException("CN_Linchpin, addLinkup: attempt to add a linkup when locked!");
		}
	}



	protected ArrayList<Integer> fireRipples() throws CN_FatalException
	{
		ArrayList<Integer> returnValue = new ArrayList<Integer>();

		for(CN_Ripplepoint ripplepoint : linkups)
		{
			returnValue.add(ripplepoint.updateFlipState());
		}

		return returnValue;
	}

	public ArrayList<Integer> flip() throws CN_FatalException
	{
		if(flipState == FlipState.UNFLIPPED)
			flipState = FlipState.FLIPPED;
		else
			flipState = FlipState.UNFLIPPED;

		return fireRipples();
	}



	public void printBasicInfo()
	{
		super.printBasicInfo();
		System.out.println("LINKUPS:");
		for(int i = 0; i < linkups.size(); i++)
		{
			System.out.println(linkups.get(i).identity);
		}
	}

}
