package cnpc.engine;

class CN_TimelineCard extends CN_GameCard
//public abstract class CN_TimelineCard extends CN_GameCard
{
	public static enum FlipState {FLIPPED, UNFLIPPED};
	FlipState flipState;

	public final int year;


	public CN_TimelineCard(int cardNumber_in, String identity_in, String cardName_in, int year_in)
	{
		super(cardNumber_in, identity_in, cardName_in);
		year = year_in;
		flipState = FlipState.UNFLIPPED;
	}


	public boolean getIsFlipped()
	{
		if(flipState == FlipState.FLIPPED)
			return true;
		else
			return false;
	}

	/*
	 * If the card is a ripplepoint and is patched, return the cardNumber of the patch.
	 * Else, return CN_Constants.NULLPATCH.
	 */
	public int getPatchedByForGs()
	{
		if(this instanceof CN_Ripplepoint)
			return ((CN_Ripplepoint)this).patchedBy;
		else
			return CN_Constants.NULL_PATCH;
	}

	public void printBasicInfo()
	{
		System.out.println("Identity: " + identity);
		System.out.println("CardName: " + cardName);
	}
}
