package cnpc.ui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class UI_BigImageFrame extends JFrame
{
	private final SpringLayout layout;
	private final Container content;

	public UI_BigImageFrame(UI_GameCard card, boolean isFlipped)
	{
		ImageIcon cardImage;
		String cardName;
		if(!isFlipped)
		{
			cardImage = card.frontImageLarge;
			cardName = card.cardNameFront;
		}
		else
		{
			cardImage = card.backImageLarge;
			cardName = card.cardNameBack;
		}

		layout = new SpringLayout();

		content = getContentPane();
		content.setLayout(layout);

		setTitle(cardName);
		setSize(UI_Constants.BIG_CARD_WINDOW_DIMENSION);
		setResizable(false);
		setLocation(UI_Constants.BIG_CARD_WINDOW_LOCATION);

		JLabel label;
		label = new JLabel(cardImage);
		layout.putConstraint(SpringLayout.WEST, label, 0, SpringLayout.WEST, content);
		layout.putConstraint(SpringLayout.NORTH, label, 0, SpringLayout.NORTH, content);
		content.add(label);

		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

		addWindowFocusListener
		(
			new WindowAdapter()
			{
				public void windowLostFocus(WindowEvent e)
				{
					dispose();
				}
			}
		);


		setVisible(true);
	}
}
