package cnpc.ui;

import java.util.Hashtable;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Color;
import java.awt.Font;
import javax.swing.ImageIcon;
import javax.swing.UIManager;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JButton;

class UI_Constants
{
	public static final Hashtable<Integer, UI_GameCard> playCardDirectory = new Hashtable<Integer, UI_GameCard>();
	public static final Hashtable<Integer, UI_GameCard> timelineCardDirectory = new Hashtable<Integer, UI_GameCard>();
	public static final Hashtable<Integer, UI_GameCard> idCardDirectory = new Hashtable<Integer, UI_GameCard>();
	public static final Hashtable<Integer, UI_GameCard> missionCardDirectory = new Hashtable<Integer, UI_GameCard>();


	public static final String GAME_NAME = "Chrononauts PC";
	public static final String VERSION_LABEL = "Version 1.0 Beta 2";
	public static final String GAME_DATE = "April 2006";



	public static final int TITLE_BAR_DIFFERENCE = 5;
	public static final int TITLE_BAR_HEIGHT;
	public static final int MENU_BAR_HEIGHT;
	public static final int BUTTON_HEIGHT;
	static
	{
		JFrame testFrame = new JFrame();
		JMenuBar testMenuBar = new JMenuBar();
		JButton testButton = new JButton("Test");
		testMenuBar.add(new JMenu("Test"));
		testFrame.add(testMenuBar);
		testFrame.setSize(0, 0);
		testFrame.setVisible(true);

		MENU_BAR_HEIGHT = testMenuBar.getPreferredSize().height;
		TITLE_BAR_HEIGHT = testFrame.getSize().height - TITLE_BAR_DIFFERENCE;
		BUTTON_HEIGHT = testButton.getPreferredSize().height;
		testFrame.dispose();
	}




	public static final Font PLAYER_NAME_FONT = new Font("Arial", Font.BOLD, 14);
	public static final Font PLAYER_PERSONALITY_FONT = new Font("Arial", Font.BOLD, 14);
	public static final Color PLAYER_PERSONALITY_COLOR = Color.BLUE;
	public static final Font UNPATCHED_PARADOXES_FONT = new Font("Arial", Font.BOLD, 14);

	//todo: not sure yet
	//public static final int BUTTON_HEIGHT = 23;

	public static final int CARD_WIDTH = 90;
	public static final int CARD_HEIGHT = 140;
	public static final int TIMELINE_CARD_BORDER_WIDTH = 4;
	public static final int TIMELINE_CARD_WIDTH = CARD_WIDTH + 2 * TIMELINE_CARD_BORDER_WIDTH;
	public static final int TIMELINE_CARD_HEIGHT = CARD_HEIGHT + 2 * TIMELINE_CARD_BORDER_WIDTH;
	public static final Dimension CARD_DIMENSION = new Dimension(CARD_WIDTH, CARD_HEIGHT);
	public static final Dimension TIMELINE_CARD_DIMENSION = new Dimension(TIMELINE_CARD_WIDTH, TIMELINE_CARD_HEIGHT);
	public static final Color TIMELINE_CARD_BG_COLOR = new Color(255, 0, 0);




	public static final int MAIN_FRAME_WIDTH = 1030;
	public static final int MAIN_FRAME_HEIGHT = 720 + TITLE_BAR_HEIGHT + MENU_BAR_HEIGHT;

	public static final int MAIN_FRAME_NORTH_BUFFER = 5;
	public static final int MAIN_FRAME_WEST_BUFFER = 5;
	public static final int MAIN_FRAME_SOUTH_BUFFER = 7;
	public static final int MAIN_FRAME_EAST_BUFFER = 10;
	public static final int MAIN_MESSAGE_PANEL_SEPARATION = 5;

	public static final int MAIN_PANEL_WIDTH = 1010;
	public static final int MAIN_PANEL_HEIGHT = 650;

	public static final int MESSAGE_PANEL_WIDTH = MAIN_PANEL_WIDTH;
	public static final int MESSAGE_PANEL_HEIGHT = 30;

	public static final Font STATUS_FONT = new Font("Arial", Font.BOLD, 12);

	//Constants for UI_MainFrame
	public static final int PANE_POSITION_NORTH_X = 220;
	public static final int PANE_POSITION_NORTH_Y = 10;
	public static final int PANE_POSITION_EAST_X = 600;
	public static final int PANE_POSITION_EAST_Y = 170;
	public static final int PANE_POSITION_SOUTH_X = 220;
	public static final int PANE_POSITION_SOUTH_Y = 350;
	public static final int PANE_POSITION_WEST_X = 10;
	public static final int PANE_POSITION_WEST_Y = 170;

	public static final int IDPOSX = 800;
	public static final int MISSIONPOSX = 900;
	public static final int IDMISSIONSTARTINGPOSY = 10;
	public static final int IDMISSIONINCREMENTY = 150;

	public static final int DECKPOSX = 600;
	public static final int DECKPOSY = 10;
	public static final int DISCARDSPOSX = 700;
	public static final int DISCARDSPOSY = 10;

	public static final int NULLPLAYER = -1;

	public static final int UNPATCHED_PARADOXES_X = 250;
	public static final int UNPATCHED_PARADOXES_Y = 315;

	public static final Color UNPATCHED_PARADOX_LABEL_LOW_COLOR = Color.BLACK;
	public static final Color UNPATCHED_PARADOX_LABEL_MID_COLOR = new Color(230, 230, 0);
	public static final Color UNPATCHED_PARADOX_LABEL_HIGH_COLOR = Color.RED;
	public static final int UNPATCHED_PARADOX_LABEL_MID_THRESHOLD = 6;
	public static final int UNPATCHED_PARADOX_LABEL_HIGH_THRESHOLD = 9;




	//Constants for UI_Initializer
	public static final String PATH_TO_DATA = "../data/";
	public static final String PATH_TO_UI_DATA = "/uidata/";
	public static final String PLAY_CARDS_PATH = "playcarduidata.c2b9";
	public static final String ID_CARDS_PATH = "idcarduidata.c2b9";
	public static final String MISSION_CARDS_PATH = "missioncarduidata.c2b9";
	public static final String TIMELINE_CARDS_PATH = "timelineuidata.c2b9";

	public static final String PLAYCARDDEFAULTNAMEBACK = "Flipped Chrononauts Card";
	public static final String IDCARDDEFAULTNAMEBACK = "Flipped ID Card";
	public static final String MISSIONCARDDEFAULTNAMEBACK = "Flipped Mission Card";


	//Constants for UI_PlayerPane
	public static final int STARTINGLAYER = 20;
	public static final int NORTHX = 360;
	public static final int NORTHY = 290;
	public static final int EASTX = 190;
	public static final int EASTY = 410;
	public static final int SOUTHX = 360;
	public static final int SOUTHY = 290;
	public static final int WESTX = 190;
	public static final int WESTY = 410;


	//Constants for UI_CardPanel
	public static final String BLANK_IMAGE_PATH = PATH_TO_UI_DATA + "images/primary/misc/blank.gif";
	public static final String X_IMAGE_PATH = PATH_TO_UI_DATA + "images/primary/misc/x.gif";
	public static final String UNSTABLE_IMAGE_PATH = PATH_TO_UI_DATA + "images/primary/misc/unstable.gif";


	//Constants for UI_TimelineFrame
	public static final int STARTING_X = 5;
	public static final int STARTING_Y = 5;
	public static final int ENDING_X = 5;
	public static final int ENDING_Y = 5;
	public static final int SEPARATION_X = 4;
	public static final int SEPARATION_Y = 10;
	public static final int MAX_PER_ROW = 8;
	public static final int MAX_PER_COL = 4;
	public static final int TIMELINE_FRAME_WIDTH = MAX_PER_ROW * (SEPARATION_X + TIMELINE_CARD_WIDTH) - SEPARATION_X + STARTING_X + ENDING_X;
	public static final int TIMELINE_FRAME_HEIGHT = MAX_PER_COL * (SEPARATION_Y + TIMELINE_CARD_HEIGHT) - SEPARATION_Y + STARTING_Y + ENDING_Y + TITLE_BAR_HEIGHT;
	public static final Dimension TIMELINE_FRAME_DIMENSION = new Dimension(TIMELINE_FRAME_WIDTH, TIMELINE_FRAME_HEIGHT);
	public static final Point TIMELINE_START_LOCATION = new Point(150, 50);


	//Constants for UI_BigImageFrame
	public static final int BIG_CARD_WINDOW_X_OFFSET = 2;
	public static final int BIG_CARD_WINDOW_Y_OFFSET = TITLE_BAR_HEIGHT;
	public static final Dimension BIG_CARD_WINDOW_DIMENSION = new Dimension(325 + BIG_CARD_WINDOW_X_OFFSET, 515 + BIG_CARD_WINDOW_Y_OFFSET);
	public static final Point BIG_CARD_WINDOW_LOCATION = new Point(200, 50);



	//Constants for UI_SelectorFrame
	public static final int SELECTOR_FRAME_STARTING_X = 20;
	public static final int SELECTOR_FRAME_ENDING_X = 20;
	public static final int SELECTOR_FRAME_STARTING_Y = 20;
	public static final int SELECTOR_FRAME_ENDING_Y = 20;
	public static final int SELECTOR_FRAME_Y_SEPARATION = 5;
	public static final Point SELECTOR_FRAME_LOCATION = new Point(200, 50);


	//Constants for UI_SearchFrame
	public static final int SEARCH_FRAME_STARTING_X = 10;
	public static final int SEARCH_FRAME_ENDING_X = 10;
	public static final int SEARCH_FRAME_CARD_SEPARATION = 20;
	public static final int SEARCH_FRAME_X_DIMENSION = CARD_WIDTH * 2 + SEARCH_FRAME_STARTING_X + SEARCH_FRAME_CARD_SEPARATION + SEARCH_FRAME_ENDING_X;

	public static final int SEARCH_FRAME_BUTTON_X = SEARCH_FRAME_STARTING_X + CARD_WIDTH - 20;

	public static final int SEARCH_FRAME_STARTING_Y = 10;
	public static final int SEARCH_FRAME_ENDING_Y_NO_BUTTON = 10;
	public static final int SEARCH_FRAME_BUTTON_SEPARATION = 20;
	public static final int SEARCH_FRAME_ENDING_Y_BUTTON = 10;
	public static final int SEARCH_FRAME_Y_DIMENSION_NO_BUTTON = SEARCH_FRAME_STARTING_Y + CARD_HEIGHT + SEARCH_FRAME_ENDING_Y_NO_BUTTON + TITLE_BAR_HEIGHT;
	public static final int SEARCH_FRAME_Y_DIMENSION_BUTTON = SEARCH_FRAME_STARTING_Y + CARD_HEIGHT + SEARCH_FRAME_BUTTON_SEPARATION + BUTTON_HEIGHT + SEARCH_FRAME_ENDING_Y_BUTTON + TITLE_BAR_HEIGHT;

	public static final Point SEARCH_FRAME_LOCATION = new Point(200, 100);


	//Constants for UI_EndOfUniverseDialog
	public static final String END_OF_UNIVERSE_DIALOG_TITLE = "What was it all for, anyway?";
	public static final String END_OF_UNIVERSE_IMAGE_PATH = PATH_TO_UI_DATA + "images/primary/misc/endofuniverse.gif";
	public static final Point END_OF_UNIVERSE_DIALOG_LOCATION = new Point(150, 50);

	public static final Font END_OF_UNIVERSE_FONT =	new Font("Comic Sans MS", Font.ITALIC, 50);
	public static final Color END_OF_UNIVERSE_COLOR = Color.RED;

	public static final int END_OF_UNIVERSE_DIALOG_WEST_BUFFER = 10;
	public static final int END_OF_UNIVERSE_DIALOG_EAST_BUFFER = 10;
	public static final int END_OF_UNIVERSE_DIALOG_DESTROYED_NORTH_BUFFER = 10;
	public static final int END_OF_UNIVERSE_DIALOG_SEPARATION = 410;


	//Constants for UI_VictoryDialog
	public static final int VICTORY_DIALOG_WEST_BUFFER = 10;
	public static final int VICTORY_DIALOG_NORTH_BUFFER = 10;
	public static final int VICTORY_DIALOG_EAST_BUFFER = 10;
	public static final int VICTORY_DIALOG_SOUTH_BUFFER = 10;
	public static final Font VICTORY_FONT =	new Font("Arial", Font.BOLD, 30);
	public static final Color VICTORY_COLOR = Color.BLUE;
	public static final Point VICTORY_DIALOG_LOCATION = new Point(300, 400);

	public static final int VICTORY_TYPE_ID = 1;
	public static final int VICTORY_TYPE_MISSION = 2;
	public static final int VICTORY_TYPE_CARDS = 3;
	public static final int VICTORY_TYPE_NULL = 0;
}
